#include <config.h>
module action_base_class
!
!= Definition of Action parameter base class
!
!== version
!
! $Id: action_base_class.F90,v 1.2 2011/06/14 11:10:42 ishikawa Exp $
!
  use lattice_class
  use hmc_status_class
  use comlib
  implicit none
  private
  public :: action_parameters
  public :: set_id
  public :: get_id

  type action_parameters
  !
  ! Base type for action parameter
  !
    integer,               public  :: myid = 0               ! action ID
    character(len=CHARLEN), public :: action_name = ""
  end type

  interface set_id
  !
  ! set quark ID
  !
    module procedure set_id
  end interface

  interface get_id
  !
  ! get quark ID
  !
    module procedure get_id
  end interface

contains

subroutine set_id(this,id)
  implicit none
  class(action_parameters), intent(inout) :: this
  integer, intent(in) :: id
  this%myid = id
  return
end subroutine

function get_id(this) result(id)
  implicit none
  class(action_parameters), intent(in) :: this
  integer :: id
  id = this%myid
  return
end function

end module
