program ddhmc_io_test
use ddhmc_io_class
use lattice_class
implicit none
type(config_prof_ddhmc) :: cprof
complex(DP), allocatable :: uu(:,:,:,:,:,:,:)
real(DP) :: plq,dplq
real(DP), parameter :: PLQ_TOL = 1.0e-12_DP
integer :: iarg
character(256) :: args(10)
character(256) ::  input_fhead
character(256) :: output_fhead

if (10 /= COMMAND_ARGUMENT_COUNT()) then
  write(*,'("command input_ddhmc_fhead NDIMX NDIMY NDIMZ NDIMT NDX NDY NDZ NDT output_fhead")')
  stop
endif
do iarg=1,10
  call GET_COMMAND_ARGUMENT(iarg,args(iarg))
  args(iarg) = TRIM(args(iarg))
enddo

ddhmc_node%NTX = NTX
ddhmc_node%NTY = NTY
ddhmc_node%NTZ = NTZ
ddhmc_node%NTT = NTT

read(args(1),'(A)')input_fhead
read(args(2),*) ddhmc_node%NDIMX
read(args(3),*) ddhmc_node%NDIMY
read(args(4),*) ddhmc_node%NDIMZ
read(args(5),*) ddhmc_node%NDIMT
read(args(6),*) ddhmc_node%NDX
read(args(7),*) ddhmc_node%NDY
read(args(8),*) ddhmc_node%NDZ
read(args(9),*) ddhmc_node%NDT
read(args(10),'(A)')output_fhead

call new(ddhmc_node)

allocate(uu(COL,COL,NTT,NTZ,NTY,NTX,NDIM))
call read_ddhmc_config(input_fhead,cprof,uu)

call plaquette(uu,plq)
write(*,'(" OLD PLQ:",E24.15)')cprof%plq
write(*,'(" NEW PLQ:",E24.15)')plq
dplq = ABS(cprof%plq-plq)/ABS(cprof%plq)
write(*,'("DIFF PLQ:",E24.15)')dplq
if (dplq > PLQ_TOL) then
  write(*,'("STOP: PLQ is inconsisntent.")')
  deallocate(uu)
  stop
endif

call convert_and_save_config(output_fhead,uu,plq)
deallocate(uu)

stop
end program
