#!/usr/bin/ruby
#
# Generate DomainWall opeator kernel
#
# $Id: GenMultHop.rb,v 1.1 2010/09/01 04:20:07 ishikawa Exp $
#

require 'optparse'
require 'FieldClasses'

amu = Array.new(5)
anu = Array.new(5)
for i in 1..5
   amu[i-1] = i
   anu[i-1] = i
end

flag = 0

state = SiteRestriction.new("","blocknormal")

OptionParser.new {|opt|
  opt.on('--dagger') {
    flag = 1
  }
  opt.on('--normal') {
    flag = 0
  }
  opt.parse!(ARGV)
}

if (flag == 1) 
  puts "!======================="
  puts "! Dagger mode"
  puts "!======================="
else
  puts "!======================="
  puts "! Normal mode"
  puts "!======================="
end

puts "!================================================="

yt = Spinor.new("yt%y")
y  = Spinor.new("y")
w  = Spinor.new("w")

 q = FieldDWSpinor.new("q")
dq = FieldDWSpinor.new("dq")
vu = FieldGauge.new("vu","vector")
 
puts "    yt%y(:,:) = Z0"

for mu in amu.reverse

  print "!  mu=",mu,"\n"

  if (flag == 1) 
    gmu = -mu
  else
    gmu =  mu
  end

  ###############################################
  #  yt = yt + (1-gamma_mu) U_mu(n) q(n+mu)
  ###############################################
  if (mu != 5)
    puts  y.assign_proj_up(-gmu,q.field_shift(+mu))
    puts  w.assign_mult_u_half(vu.dir(mu).field,y,+1)
    puts yt.accum_proj_low(-gmu,w)
  else
    state.extra_boundary(+mu)
    puts  y.assign_proj_up(-gmu,q.field_shift(+mu))
    puts yt.accum_proj_low(-gmu,y)
  end

  ###############################################
  #  yt = yt + (1+gamma_mu) U_mu(n-mu)^+ q(n-mu)
  ###############################################
  if (mu != 5)
    puts  y.assign_proj_up(+gmu,q.field_shift(-mu))
    puts  w.assign_mult_u_half(vu.dir(mu).field_shift(-mu),y,-1)
    puts yt.accum_proj_low(+gmu,w)
  else
    state.extra_boundary(-mu)
    puts  y.assign_proj_up(+gmu,q.field_shift(-mu))
    puts yt.accum_proj_low(+gmu,y)
  end
end

puts "    " + dq.field.get_name + "(:,:) = " + q.field.get_name + "(:,:) - kappa * yt%y(:,:)"
